char* a[] = {"/ch/01/mix/on",  //starts at 0
             "/ch/02/mix/on",
             "/ch/03/mix/on",
             "/ch/04/mix/on",
             "/ch/05/mix/on",
             "/ch/06/mix/on",
             "/ch/07/mix/on",
             "/ch/08/mix/on",
             "/ch/09/mix/on",
             "/ch/10/mix/on",
             "/ch/11/mix/on",
             "/ch/12/mix/on",
             "/ch/13/mix/on",
             "/ch/14/mix/on",
             "/ch/15/mix/on",
             "/ch/16/mix/on",
             "/ch/01/mix/fader",
             "/ch/02/mix/fader",
             "/ch/03/mix/fader",
             "/ch/04/mix/fader",
             "/ch/05/mix/fader",
             "/ch/06/mix/fader",
             "/ch/07/mix/fader",
             "/ch/08/mix/fader",
             "/ch/09/mix/fader",
             "/ch/10/mix/fader",
             "/ch/11/mix/fader",
             "/ch/12/mix/fader",
             "/ch/13/mix/fader",
             "/ch/14/mix/fader",
             "/ch/15/mix/fader",
             "/ch/16/mix/fader",
             "/ch/01/mix/pan",
             "/ch/02/mix/pan",
             "/ch/03/mix/pan",
             "/ch/04/mix/pan",
             "/ch/05/mix/pan",
             "/ch/06/mix/pan",
             "/ch/07/mix/pan",
             "/ch/08/mix/pan",
             "/ch/09/mix/pan",
             "/ch/10/mix/pan",
             "/ch/11/mix/pan",
             "/ch/12/mix/pan",
             "/ch/13/mix/pan",
             "/ch/14/mix/pan",
             "/ch/15/mix/pan",
             "/ch/16/mix/pan",
             "/rtn/aux/mix/on",
             "/rtn/1/mix/on",
             "/rtn/2/mix/on",
             "/rtn/3/mix/on",
             "/rtn/4/mix/on",
             "/dca/1/on",
             "/dca/2/on",
             "/dca/3/on",
             "/dca/4/on",
             "/bus/1/mix/on",
             "/bus/2/mix/on",
             "/bus/3/mix/on",
             "/bus/4/mix/on",
             "/bus/5/mix/on",
             "/bus/6/mix/on",
             "/lr/mix/on",
             "/fx/3/par/02",                      // Get Tap Tempo
             "/rtn/aux/mix/fader",
             "/rtn/1/mix/fader",
             "/rtn/2/mix/fader",
             "/rtn/3/mix/fader",
             "/rtn/4/mix/fader",
             "/dca/1/fader",
             "/dca/2/fader",
             "/dca/3/fader",
             "/dca/4/fader",
             "/bus/1/mix/fader",
             "/bus/2/mix/fader",
             "/bus/3/mix/fader",
             "/bus/4/mix/fader",
             "/bus/5/mix/fader",
             "/bus/6/mix/fader",
             "/lr/mix/fader",
             "/rtn/aux/mix/pan",
             "/rtn/1/mix/pan",
             "/rtn/2/mix/pan",
             "/rtn/3/mix/pan",
             "/rtn/4/mix/pan",
             "0",
             "0",
             "0",
             "0",
             "/bus/1/mix/pan",
             "/bus/2/mix/pan",
             "/bus/3/mix/pan",
             "/bus/4/mix/pan",
             "/bus/5/mix/pan",
             "/bus/6/mix/pan",
             "/lr/mix/pan",
            };


#include <LedControl.h>
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <OSCMessage.h>
#include <SimpleRotary.h>
#include <WiFiManager.h>
#include <EEPROM.h>
LedControl lc = LedControl(15, 0, 2, 1);                        // Pin 15 to MAX7219 1DIN, PIN 0 to 13CLK, PIN 2 to 12LOAD
SimpleRotary rotary1(16, 14, 100);                              // For Rotary 1, pins D0,D5
SimpleRotary rotary2(12, 13, 100);                              // For Rotary 2, pins D6,D7
WiFiUDP Udp;
OSCErrorCode error;
char xAirIP[15];                                                // IP Address of Mixer
const unsigned int xAirPort = 10024;                            // Port of Mixer, 10024 for X-Air, 10023 for X32
const unsigned int myPort = 8888;                               // Port for recieving OSC messages
char XREMOTENFB[] = "/xremote";                                 // Command to send to tell XAir mixer to keep updating this device
unsigned long CurrentMillis;
unsigned long HEARTBEAT = 8000;
unsigned long lastBeat;
unsigned long startTime;                                        // calculate Tempo from millis
unsigned long Tempo;                                            // Keeping track of counter for blinking tempo LED
unsigned long delaytime;                                        // Delay time
unsigned long pageSwitchTime;                                   // Keep track of time between switching between Page 1 and 0, to help with debouncing
unsigned long DebounceL       = 200;                            // Time between button presses for debouncing
unsigned long Btn_Time[6];                                      // Keep track of time for last button press
unsigned long Pan_Time1;
unsigned long Mute_Time1;
unsigned long WifiSettingsDebounce;
unsigned long WifiSettingsEnterTime;
float fader[16];                                                // Handle the 16 fader positions
float pan[16];                                                  // Handle the 16 pan positions
float tempo[1];                                                 // Store tap tempo
int mute[16];                                                   // Handle the 16 mute buttons
int  BtnNo                 = 4;                                 // Total number of buttons
int  Btn_Pins[5]           = {100, 1, 3, 5, 4};                 // Button arduino pins (100 if absent) Button Pins are (TX, RX, D1, D2)
int  Btn_Read[5]           = {LOW};                             // Integers for storing data related to pins
int  Btn_Last[5]           = {LOW};                             // Integers for storing data related to pins
int  start                 = false;
int  pageledspeed          = 2000;                              // Speed at which page LED blinks
int  panEnterTime          = 1000;                              // How long to hold UP button before entering PAN mode for Rotary 2
int  bulkMuteTime          = 1500;                              // How long to hold MUTE button before enabling Bulk Mute Mode
int  setEnterTime          = 6000;                              // How long to hold buttons for before entering Config Mode
int  wifiPingTime          = 2000;                              // How often to Ping and see if mixer is up
int  oscPollSpeed          = 25;                                // Speed to send OSC commands when running UpdateController()
int  wifidownstatus        = 0;
int  panEnterEnable        = 0;
int  panEngage             = 0;
int  muteEnterEnable       = 0;
int  muteOption            = 0;
int  wifiSettings          = 0;
int  page                  = 0;                                 // Handle Current Page
int  selectedchannel       = 0;                                 // What channel is currently selected
int  rotary1Dir            = 0;                                 // Read what direction the Rotary Encoder 1 is spinning
int  rotary2Dir            = 0;                                 // Read what direction the Rotary Encoder 2 is spinning
int  pageled0              = 0;
int  pageled1              = 0;



void setup()
{
  CurrentMillis  = millis();
  loadCredentials();
  // Setup rotary for Low triggering
  rotary1.setTrigger(HIGH);
  rotary2.setTrigger(HIGH);
  rotary1.setErrorDelay(35);
  rotary2.setErrorDelay(35);
  //Wake Max7219 chip for driving LEDS
  lc.shutdown(0, false);                                        // turn off power saving
  lc.setIntensity(0, 15);                                       // sets brightness (0~15 possible values)
  lc.clearDisplay(0);                                           // clear screen
  //start WiFi
  //  WiFi.begin(ssid, pass);
  WiFi.begin();
  WifiStatus();
  Udp.begin(myPort);
  delay(100);
  UpdateController();                                           // Run this Twice, for some reason only running it once doesn't work well on a weak WiFi connection
  UpdateController();
}





void loop()
{
  CurrentMillis  = millis();
  if (CurrentMillis - lastBeat > HEARTBEAT)                            // Keep Connection to XR18 Alive
  {
    SendOSC(XREMOTENFB);
    lastBeat = CurrentMillis;
  }
  WifiStatus();                                                        // Check Wifi Status
  ReadOSC();                                                           // Read incoming OSC commands
  ReadButtons();
  SelectChannel();                                                     // Section for all LED related things

}







// This Section handles all button inputs and related triggering commands

void ReadButtons()
{
  for (int i = 1; i <= BtnNo; i++) Btn_Read[i] = digitalRead(Btn_Pins[i]);
  rotary1Dir = rotary1.rotate();
  rotary2Dir = rotary2.rotate();
  for (int f = 0; f <= BtnNo; f++) {
    Btn_Last[f] == Btn_Read[f];
  }
  // Page Down button

  if (Btn_Read[1] == LOW && ((CurrentMillis - Btn_Time[1]) > DebounceL) && page == 1)
  {
    page = 0;
    Btn_Time[1] = CurrentMillis;
    pageled0 = 1;
    PageSelectInfoLED();
    UpdateController();
    panEnterEnable = 0;
  }
  else if (panEngage == 0) {
    pageled0 = 0;
  }
  // Page Up button
  if (Btn_Read[2] == LOW && ((CurrentMillis - Btn_Time[2]) > DebounceL) && panEnterEnable == 0)
  {
    Pan_Time1 = CurrentMillis;
    panEnterEnable = 1;
  }

  if (Btn_Read[2] == HIGH && Btn_Last[2] == LOW && ((CurrentMillis - Btn_Time[2]) > DebounceL) && page == 0 && panEnterEnable == 1)
  {
    page = 1;
    Btn_Time[2] = CurrentMillis;
    pageled1 = 1;
    PageSelectInfoLED();
    UpdateController();
  }
  if (Btn_Read[2] == LOW && ((CurrentMillis - Pan_Time1) > panEnterTime))
  {
    pageled1 = 1;
    panEnterEnable = 0;
    Btn_Time[2] = CurrentMillis;
    panEngage = 1;
  }
  else {
    panEngage = 0;
  }

  //flash LED for page 1
  if (page == 1 && (CurrentMillis - Btn_Time[5]) > pageledspeed)
  {
    pageled1 = 1;
    Btn_Time[5] = CurrentMillis;
  }
  else if (pageled1 == 1 && (CurrentMillis - Btn_Time[5]) > 40 && panEngage == 0)
  {
    pageled1 = 0;
  }

  // Channel select rotary
  if (rotary1Dir == 1 && selectedchannel <= 14)
  {
    selectedchannel = selectedchannel + 1;
  }
  if (rotary1Dir == 2 && selectedchannel >= 1)
  {
    selectedchannel = selectedchannel - 1;
  }
  //Volume change rotary
  if (rotary2Dir == 1 && panEngage == 0)
  {
    if (page == 0)
    {
      SendFloatOSC(a[selectedchannel + 16], fader[selectedchannel] + .03);
    }
    else if (page == 1)
    {
      SendFloatOSC(a[selectedchannel + 65], fader[selectedchannel] + .03);
    }
  }
  if (rotary2Dir == 2 && panEngage == 0)
  {
    if (page == 0)
    {
      SendFloatOSC(a[selectedchannel + 16], fader[selectedchannel] - .03);
    }
    else if (page == 1)
    {
      SendFloatOSC(a[selectedchannel + 65], fader[selectedchannel] - .03);
    }
  }
  //Pan change rotary
  if (rotary2Dir == 1 && panEngage == 1)
  {
    if (page == 0)
    {
      SendFloatOSC(a[selectedchannel + 32], pan[selectedchannel] + .10);
    }
    else if (page == 1)
    {
      SendFloatOSC(a[selectedchannel + 81], pan[selectedchannel] + .10);
    }
  }
  if (rotary2Dir == 2 && panEngage == 1)
  {
    if (page == 0)
    {
      SendFloatOSC(a[selectedchannel + 32], pan[selectedchannel] - .10);
    }
    else if (page == 1)
    {
      SendFloatOSC(a[selectedchannel + 81], pan[selectedchannel] - .10);
    }
  }
  // Calculate Tempo from button presses
  if (Btn_Read[3] == LOW && ((CurrentMillis - Btn_Time[3]) > 10))
  {
    if (Btn_Read[3] == LOW  &&  start == false)
    {
      startTime = CurrentMillis;
      start = true;
    }
    else if (Btn_Read[3] == LOW &&  start == true && ((CurrentMillis - Btn_Time[3]) > 50))
    {
      start = false;
      delaytime = constrain ((CurrentMillis - startTime), 100, 3000);     // this is used to restrict the output of the tempo to a range between 11ms and 3000ms
      SendIntOSC(a[64], delaytime);
    }
    Btn_Time[3] = CurrentMillis;
  }
  if (CurrentMillis - startTime > 3000)(start = false);



  // MUTE button, PRESS and HOLD for bulkMuteTime to toggle in bulk
  if (Btn_Read[4] == LOW && ((CurrentMillis - Btn_Time[4]) > DebounceL) && muteEnterEnable == 0)
  {
    Mute_Time1 = CurrentMillis;
    muteEnterEnable = 1;
  }

  if (Btn_Read[4] == HIGH && Btn_Last[4] == LOW && ((CurrentMillis - Btn_Time[4]) > DebounceL) && muteEnterEnable == 1)
  {
    Btn_Time[4] = CurrentMillis;
    muteEnterEnable = 0;
    if (mute[selectedchannel] == 1 && (page == 0))(SendIntOSC(a[selectedchannel], 0));
    else if (page == 0)(SendIntOSC(a[selectedchannel], 1));
    if (mute[selectedchannel] == 1 && (page == 1))(SendIntOSC(a[selectedchannel + 48], 0));
    else if (page == 1)(SendIntOSC(a[selectedchannel + 48], 1));
  }
  if (Btn_Read[4] == LOW && ((CurrentMillis - Mute_Time1) > bulkMuteTime))
  {
    muteEnterEnable = 0;
    Btn_Time[4] = CurrentMillis;
    if (mute[selectedchannel] == 1 && (page == 0) && muteOption == 0)(muteOption = 1);
    else if (mute[selectedchannel] == 0 && (page == 0) && muteOption == 0)(muteOption = 2);
    if (mute[selectedchannel] == 1 && (page == 1) && muteOption == 0)(muteOption = 3);
    else if (mute[selectedchannel] == 0 && (page == 1) && muteOption == 0)(muteOption = 4);
    if (muteOption == 1)(SendIntOSC(a[selectedchannel], 0));
    else if (muteOption == 2)(SendIntOSC(a[selectedchannel], 1));
    if (muteOption == 3)(SendIntOSC(a[selectedchannel + 48], 0));
    else if (muteOption == 4)(SendIntOSC(a[selectedchannel + 48], 1));
  }
  else if (muteOption >= 1)(muteOption = 0);

  // Config Wifi Section
  if (Btn_Read[1] == LOW && Btn_Read[2] == LOW && Btn_Read[3] == LOW && CurrentMillis - WifiSettingsDebounce > DebounceL && wifiSettings == 0)
  {
    wifiSettings = 1;
    WifiSettingsEnterTime = CurrentMillis;
  }
  if (Btn_Read[1] == HIGH && Btn_Last[1] == LOW && wifiSettings == 1) (wifiSettings = 0 && (WifiSettingsDebounce = CurrentMillis));
  else if (Btn_Read[2] == HIGH && Btn_Last[2] == LOW && wifiSettings == 1) (wifiSettings = 0 && (WifiSettingsDebounce = CurrentMillis));
  else if (Btn_Read[3] == HIGH && Btn_Last[3] == LOW && wifiSettings == 1) (wifiSettings = 0 && (WifiSettingsDebounce = CurrentMillis));
  if (Btn_Read[1] == LOW && Btn_Read[2] == LOW && Btn_Read[3] == LOW && CurrentMillis - WifiSettingsEnterTime > setEnterTime && wifiSettings == 1)
  {
    wifiSettings = 0;
    WifiSettingsConfig();
  }
}







// This Section covers all LED configuration

void SelectChannel()
{
  SelectLED();
  SetFaderLED();
  SetPanLED();
  PageSelectInfoLED();
  MuteLeds();
  TempoLed();

}




void SetPanLED()
{
  int panlightrow[] = {6, 6, 7, 6, 6};
  int panlight[] = {6, 7, 3, 5, 4};
  int panlevel = map((pan[selectedchannel] * 1000), 0, 1000, 2, 5);
  // loop over the LED array:
  for (int b = 2; b <= BtnNo; b++) {
    if (b < panlevel)(lc.setLed(0, panlightrow[b], panlight[b], true));
    else (lc.setLed(0, panlightrow[b], panlight[b], false));
  }
  int panlevel1 = map((pan[selectedchannel] * 1000), 650, 000, 0, 2);
  // loop over the LED array:
  for (int d = 0; d <= 1; d++) {
    if (d < panlevel1)(lc.setLed(0, panlightrow[d], panlight[d], true));
    else (lc.setLed(0, panlightrow[d], panlight[d], false));
  }
}




void SetFaderLED()
{
  int faderlightrow[] = {6, 6, 6, 6, 5, 5, 5, 5, 5, 5, 5, 5};
  int faderlight[] = {3, 2, 1, 0, 0, 1, 2, 3, 4, 5, 6, 7};
  int faderlevel = map((fader[selectedchannel] * 1000), -50, 850, 0, 12);
  // loop over the LED array:
  for (int r = 0; r <= 11; r++) {
    // if the array element's index is less than ledLevel,
    // turn the pin for this element on:
    if (r < faderlevel) (lc.setLed(0, faderlightrow[r], faderlight[r], true));
    // turn off all pins higher than the ledLevel:
    else (lc.setLed(0, faderlightrow[r], faderlight[r], false));
  }
}




void SelectLED()
{
  if (selectedchannel == 0)  (lc.setLed(0, 1, 0, true)); else (lc.setLed(0, 1, 0, false));   // Set Mute LED 0
  if (selectedchannel == 1)  (lc.setLed(0, 1, 1, true)); else (lc.setLed(0, 1, 1, false));   // Set Mute LED 1
  if (selectedchannel == 2)  (lc.setLed(0, 1, 2, true)); else (lc.setLed(0, 1, 2, false));   // Set Mute LED 2
  if (selectedchannel == 3)  (lc.setLed(0, 1, 3, true)); else (lc.setLed(0, 1, 3, false));   // Set Mute LED 3
  if (selectedchannel == 4)  (lc.setLed(0, 1, 4, true)); else (lc.setLed(0, 1, 4, false));   // Set Mute LED 4
  if (selectedchannel == 5)  (lc.setLed(0, 1, 5, true)); else (lc.setLed(0, 1, 5, false));   // Set Mute LED 5
  if (selectedchannel == 6)  (lc.setLed(0, 1, 6, true)); else (lc.setLed(0, 1, 6, false));   // Set Mute LED 6
  if (selectedchannel == 7)  (lc.setLed(0, 1, 7, true)); else (lc.setLed(0, 1, 7, false));   // Set Mute LED 7
  if (selectedchannel == 8)  (lc.setLed(0, 2, 7, true)); else (lc.setLed(0, 2, 7, false));   // Set Mute LED 8
  if (selectedchannel == 9)  (lc.setLed(0, 2, 6, true)); else (lc.setLed(0, 2, 6, false));   // Set Mute LED 9
  if (selectedchannel == 10) (lc.setLed(0, 2, 5, true)); else (lc.setLed(0, 2, 5, false));  // Set Mute LED 10
  if (selectedchannel == 11) (lc.setLed(0, 2, 4, true)); else (lc.setLed(0, 2, 4, false));  // Set Mute LED 11
  if (selectedchannel == 12) (lc.setLed(0, 2, 3, true)); else (lc.setLed(0, 2, 3, false));  // Set Mute LED 12
  if (selectedchannel == 13) (lc.setLed(0, 2, 2, true)); else (lc.setLed(0, 2, 2, false));  // Set Mute LED 13
  if (selectedchannel == 14) (lc.setLed(0, 2, 1, true)); else (lc.setLed(0, 2, 1, false));  // Set Mute LED 14
  if (selectedchannel == 15) (lc.setLed(0, 2, 0, true)); else (lc.setLed(0, 2, 0, false));  // Set Mute LED 15
}




void PageSelectInfoLED()
{
  if (pageled0 == 1) (lc.setLed(0, 4, 7, true)); else if (pageled0 == 0)(lc.setLed(0, 4, 7, false));
  if (pageled1 == 1) (lc.setLed(0, 4, 6, true)); else if (pageled1 == 0)(lc.setLed(0, 4, 6, false));
}




void TempoLed()
{
  // Flash Tempo LED
  if (CurrentMillis - Tempo > (tempo[0] * 3000)) (Tempo = CurrentMillis, lc.setLed(0, 4, 3, true)); else if (CurrentMillis - Tempo > 40) (lc.setLed(0, 4, 3, false));
}




void MuteLeds()
{
  if (mute[0] == 0) (lc.setLed(0, 0, 0, true)); else (lc.setLed(0, 0, 0, false));   // Set Mute LED 0
  if (mute[1] == 0) (lc.setLed(0, 0, 1, true)); else (lc.setLed(0, 0, 1, false));   // Set Mute LED 1
  if (mute[2] == 0) (lc.setLed(0, 0, 2, true)); else (lc.setLed(0, 0, 2, false));   // Set Mute LED 2
  if (mute[3] == 0) (lc.setLed(0, 0, 3, true)); else (lc.setLed(0, 0, 3, false));   // Set Mute LED 3
  if (mute[4] == 0) (lc.setLed(0, 0, 4, true)); else (lc.setLed(0, 0, 4, false));   // Set Mute LED 4
  if (mute[5] == 0) (lc.setLed(0, 0, 5, true)); else (lc.setLed(0, 0, 5, false));   // Set Mute LED 5
  if (mute[6] == 0) (lc.setLed(0, 0, 6, true)); else (lc.setLed(0, 0, 6, false));   // Set Mute LED 6
  if (mute[7] == 0) (lc.setLed(0, 0, 7, true)); else (lc.setLed(0, 0, 7, false));   // Set Mute LED 7
  if (mute[8] == 0) (lc.setLed(0, 3, 7, true)); else (lc.setLed(0, 3, 7, false));   // Set Mute LED 8
  if (mute[9] == 0) (lc.setLed(0, 3, 6, true)); else (lc.setLed(0, 3, 6, false));   // Set Mute LED 9
  if (mute[10] == 0) (lc.setLed(0, 3, 5, true)); else (lc.setLed(0, 3, 5, false));  // Set Mute LED 10
  if (mute[11] == 0) (lc.setLed(0, 3, 4, true)); else (lc.setLed(0, 3, 4, false));  // Set Mute LED 11
  if (mute[12] == 0) (lc.setLed(0, 3, 3, true)); else (lc.setLed(0, 3, 3, false));  // Set Mute LED 12
  if (mute[13] == 0) (lc.setLed(0, 3, 2, true)); else (lc.setLed(0, 3, 2, false));  // Set Mute LED 13
  if (mute[14] == 0) (lc.setLed(0, 3, 1, true)); else (lc.setLed(0, 3, 1, false));  // Set Mute LED 14
  if (mute[15] == 0) (lc.setLed(0, 3, 0, true)); else (lc.setLed(0, 3, 0, false));  // Set Mute LED 15
}







//This Section handles EEPROM stuff for remembering IP address of mixer across reboots

void loadCredentials() {
  EEPROM.begin(256);
  EEPROM.get(0, xAirIP);
  EEPROM.end();

}




void saveCredentials() {
  EEPROM.begin(256);
  EEPROM.put(0, xAirIP);
  EEPROM.commit();
  EEPROM.end();
}






// This section handles On-The-Fly Wifi status and config

void WifiStatus()
{
  while (WiFi.status() != WL_CONNECTED) {                    // Chase LEDs untill Wifi Connects
    wifidownstatus = 1;
    ReadButtons();                                           // Read buttons So Wifi Config mode can be entered
    for (int row = 0; row < 8; row++)
    {
      for (int col = 0; col < 8; col++)
      {
        lc.setLed(0, col, row, true);                        // turns on LED at col, row
        delay(10);
      }
    }

    for (int row = 0; row < 8; row++)
    {
      for (int col = 0; col < 8; col++)
      {
        lc.setLed(0, col, row, false);                       // turns off LED at col, row
        delay(10);
      }
    }
  }
  if (wifidownstatus == 1)
  {
    UpdateController();
    wifidownstatus = 0;
  }
}




void WifiSettingsConfig()
{
  for (int row = 0; row < 8; row++)
  {
    for (int col = 0; col < 8; col++)
    {
      lc.setLed(0, col, row, true);                          // turns on all LEDs for settings config mode
    }
  }
  WiFi.disconnect(true);
  WiFiManager wifiManager;
  wifiManager.setDebugOutput(false);                        // Disable Debugging
  WiFiManagerParameter mixer_ip("MixerIP", "XAir Mixer IP", xAirIP, 15);
  WiFiManagerParameter mixer_ip_text("<hr><br><p>IP Address of XAir Mixer</p>");
  WiFiManagerParameter fx_info_text("<hr><br><p>TapTempo is expecting Stereo Delay Plugin to be in FX Slot 3<br>and will not work any other way, or with most other plugins</p>");
  wifiManager.addParameter(&mixer_ip_text);
  wifiManager.addParameter(&mixer_ip);
  wifiManager.addParameter(&fx_info_text);
  wifiManager.startConfigPortal("XAir-WC1-Config");
  strcpy(xAirIP, mixer_ip.getValue());
  saveCredentials();
  ESP.restart();
}






// This section handles all OSC related things

void UpdateController()
{
  // Update faders
  if (page == 0)
  {
    for (byte i = 0; i <= 47; i++)
    {
      SendOSC(a[i]);
      ReadOSC();
      delay(oscPollSpeed);
    }
    SendOSC(a[64]);                                          // Get Tap Tempo, even on page 0
    ReadOSC();
    delay(oscPollSpeed);
  }
  else if (page == 1)
  {
    for (byte i = 48; i <= 96; i++)
    {
      SendOSC(a[i]);
      ReadOSC();
      delay(oscPollSpeed);

    }
  }
}




void ReadOSC()
{
  // Check if packet was received
  int size = Udp.parsePacket();
  if (size < 1)
    return;

  // Create a message
  OSCMessage msg;
  while (size--)
    msg.fill(Udp.read());

  // Check for errors
  if (msg.hasError()) {
    errorHandler(msg);
    msg.empty();
    return;
  }
  // Route messages
  if (page == 0)
  {
    if (msg.fullMatch(a[0]))mute[0]         = msg.getInt(0);
    else if (msg.fullMatch(a[0]))mute[0]    = msg.getInt(0);
    else if (msg.fullMatch(a[1]))mute[1]    = msg.getInt(0);
    else if (msg.fullMatch(a[2]))mute[2]    = msg.getInt(0);
    else if (msg.fullMatch(a[3]))mute[3]    = msg.getInt(0);
    else if (msg.fullMatch(a[4]))mute[4]    = msg.getInt(0);
    else if (msg.fullMatch(a[5]))mute[5]    = msg.getInt(0);
    else if (msg.fullMatch(a[6]))mute[6]    = msg.getInt(0);
    else if (msg.fullMatch(a[7]))mute[7]    = msg.getInt(0);
    else if (msg.fullMatch(a[8]))mute[8]    = msg.getInt(0);
    else if (msg.fullMatch(a[9]))mute[9]    = msg.getInt(0);
    else if (msg.fullMatch(a[10]))mute[10]  = msg.getInt(0);
    else if (msg.fullMatch(a[11]))mute[11]  = msg.getInt(0);
    else if (msg.fullMatch(a[12]))mute[12]  = msg.getInt(0);
    else if (msg.fullMatch(a[13]))mute[13]  = msg.getInt(0);
    else if (msg.fullMatch(a[14]))mute[14]  = msg.getInt(0);
    else if (msg.fullMatch(a[15]))mute[15]  = msg.getInt(0);
    else if (msg.fullMatch(a[16]))fader[0]  = msg.getFloat(0);
    else if (msg.fullMatch(a[17]))fader[1]  = msg.getFloat(0);
    else if (msg.fullMatch(a[18]))fader[2]  = msg.getFloat(0);
    else if (msg.fullMatch(a[19]))fader[3]  = msg.getFloat(0);
    else if (msg.fullMatch(a[20]))fader[4]  = msg.getFloat(0);
    else if (msg.fullMatch(a[21]))fader[5]  = msg.getFloat(0);
    else if (msg.fullMatch(a[22]))fader[6]  = msg.getFloat(0);
    else if (msg.fullMatch(a[23]))fader[7]  = msg.getFloat(0);
    else if (msg.fullMatch(a[24]))fader[8]  = msg.getFloat(0);
    else if (msg.fullMatch(a[25]))fader[9]  = msg.getFloat(0);
    else if (msg.fullMatch(a[26]))fader[10] = msg.getFloat(0);
    else if (msg.fullMatch(a[27]))fader[11] = msg.getFloat(0);
    else if (msg.fullMatch(a[28]))fader[12] = msg.getFloat(0);
    else if (msg.fullMatch(a[29]))fader[13] = msg.getFloat(0);
    else if (msg.fullMatch(a[30]))fader[14] = msg.getFloat(0);
    else if (msg.fullMatch(a[31]))fader[15] = msg.getFloat(0);
    else if (msg.fullMatch(a[32]))pan[0]    = msg.getFloat(0);
    else if (msg.fullMatch(a[33]))pan[1]    = msg.getFloat(0);
    else if (msg.fullMatch(a[34]))pan[2]    = msg.getFloat(0);
    else if (msg.fullMatch(a[35]))pan[3]    = msg.getFloat(0);
    else if (msg.fullMatch(a[36]))pan[4]    = msg.getFloat(0);
    else if (msg.fullMatch(a[37]))pan[5]    = msg.getFloat(0);
    else if (msg.fullMatch(a[38]))pan[6]    = msg.getFloat(0);
    else if (msg.fullMatch(a[39]))pan[7]    = msg.getFloat(0);
    else if (msg.fullMatch(a[40]))pan[8]    = msg.getFloat(0);
    else if (msg.fullMatch(a[41]))pan[9]    = msg.getFloat(0);
    else if (msg.fullMatch(a[42]))pan[10]   = msg.getFloat(0);
    else if (msg.fullMatch(a[43]))pan[11]   = msg.getFloat(0);
    else if (msg.fullMatch(a[44]))pan[12]   = msg.getFloat(0);
    else if (msg.fullMatch(a[45]))pan[13]   = msg.getFloat(0);
    else if (msg.fullMatch(a[46]))pan[14]   = msg.getFloat(0);
    else if (msg.fullMatch(a[47]))pan[15]   = msg.getFloat(0);
    else if (msg.fullMatch(a[64]))tempo[0]  = msg.getFloat(0);
  }
  if (page == 1)
  {
    if (msg.fullMatch(a[48]))mute[0]         = msg.getInt(0);
    else if (msg.fullMatch(a[49]))mute[1]    = msg.getInt(0);
    else if (msg.fullMatch(a[50]))mute[2]    = msg.getInt(0);
    else if (msg.fullMatch(a[51]))mute[3]    = msg.getInt(0);
    else if (msg.fullMatch(a[52]))mute[4]    = msg.getInt(0);
    else if (msg.fullMatch(a[53]))mute[5]    = msg.getInt(0);
    else if (msg.fullMatch(a[54]))mute[6]    = msg.getInt(0);
    else if (msg.fullMatch(a[55]))mute[7]    = msg.getInt(0);
    else if (msg.fullMatch(a[56]))mute[8]    = msg.getInt(0);
    else if (msg.fullMatch(a[57]))mute[9]    = msg.getInt(0);
    else if (msg.fullMatch(a[58]))mute[10]   = msg.getInt(0);
    else if (msg.fullMatch(a[59]))mute[11]   = msg.getInt(0);
    else if (msg.fullMatch(a[60]))mute[12]   = msg.getInt(0);
    else if (msg.fullMatch(a[61]))mute[13]   = msg.getInt(0);
    else if (msg.fullMatch(a[62]))mute[14]   = msg.getInt(0);
    else if (msg.fullMatch(a[63]))mute[15]   = msg.getInt(0);
    else if (msg.fullMatch(a[64]))tempo[0]   = msg.getFloat(0);
    else if (msg.fullMatch(a[65]))fader[0]   = msg.getFloat(0);
    else if (msg.fullMatch(a[66]))fader[1]   = msg.getFloat(0);
    else if (msg.fullMatch(a[67]))fader[2]   = msg.getFloat(0);
    else if (msg.fullMatch(a[68]))fader[3]   = msg.getFloat(0);
    else if (msg.fullMatch(a[69]))fader[4]   = msg.getFloat(0);
    else if (msg.fullMatch(a[70]))fader[5]   = msg.getFloat(0);
    else if (msg.fullMatch(a[71]))fader[6]   = msg.getFloat(0);
    else if (msg.fullMatch(a[72]))fader[7]   = msg.getFloat(0);
    else if (msg.fullMatch(a[73]))fader[8]   = msg.getFloat(0);
    else if (msg.fullMatch(a[74]))fader[9]   = msg.getFloat(0);
    else if (msg.fullMatch(a[75]))fader[10]  = msg.getFloat(0);
    else if (msg.fullMatch(a[76]))fader[11]  = msg.getFloat(0);
    else if (msg.fullMatch(a[77]))fader[12]  = msg.getFloat(0);
    else if (msg.fullMatch(a[78]))fader[13]  = msg.getFloat(0);
    else if (msg.fullMatch(a[79]))fader[14]  = msg.getFloat(0);
    else if (msg.fullMatch(a[80]))fader[15]  = msg.getFloat(0);
    else if (msg.fullMatch(a[81]))pan[0]     = msg.getFloat(0);
    else if (msg.fullMatch(a[82]))pan[1]     = msg.getFloat(0);
    else if (msg.fullMatch(a[83]))pan[2]     = msg.getFloat(0);
    else if (msg.fullMatch(a[84]))pan[3]     = msg.getFloat(0);
    else if (msg.fullMatch(a[85]))pan[4]     = msg.getFloat(0);
    else if (msg.fullMatch(a[86]))pan[5]     = msg.getFloat(0);
    else if (msg.fullMatch(a[87]))pan[6]     = msg.getFloat(0);
    else if (msg.fullMatch(a[88]))pan[7]     = msg.getFloat(0);
    else if (msg.fullMatch(a[89]))pan[8]     = msg.getFloat(0);
    else if (msg.fullMatch(a[90]))pan[9]     = msg.getFloat(0);
    else if (msg.fullMatch(a[91]))pan[10]    = msg.getFloat(0);
    else if (msg.fullMatch(a[92]))pan[11]    = msg.getFloat(0);
    else if (msg.fullMatch(a[93]))pan[12]    = msg.getFloat(0);
    else if (msg.fullMatch(a[94]))pan[13]    = msg.getFloat(0);
    else if (msg.fullMatch(a[95]))pan[14]    = msg.getFloat(0);
    else if (msg.fullMatch(a[96]))pan[15]    = msg.getFloat(0);
  }
  msg.empty();
}




void errorHandler(OSCMessage msg)
{
  error = msg.getError();
  msg.empty();
}




// Send OSC message
void SendOSC(char* address)
{
  OSCMessage msg(address);
  Udp.beginPacket(xAirIP, xAirPort);
  msg.send(Udp);
  Udp.endPacket();
  msg.empty();
}




// Send OSC message with int value
void SendIntOSC(char* address, int val)
{
  OSCMessage msg(address);
  msg.add(val);
  Udp.beginPacket(xAirIP, xAirPort);
  msg.send(Udp);
  Udp.endPacket();
  msg.empty();
}




// Send OSC message with float value
void SendFloatOSC(char* address, float val)
{
  OSCMessage msg(address);
  msg.add(val);
  Udp.beginPacket(xAirIP, xAirPort);
  msg.send(Udp);
  Udp.endPacket();
  msg.empty();
}
